check_PROGRAMS = \
  test-clutk \
  test-clutk-perf \
  test-clutk-text

test_clutk_SOURCES = \
  test-actor.c \
  test-clutk.c \
  test-dnd.c \
  test-em-support.c \
  test-effect.c \
  test-effect-animation.c \
  test-effect-context.c \
  test-effect-drop-shadow.c \
  test-layer-actor.c \
  test-menu.c \
  test-render-target.c \
  test-surface-blur.c

test_clutk_perf_SOURCES = \
  test-clutk-perf.c

test_clutk_text_SOURCES = \
  test-clutk-text.c

test_clutk_CPPFLAGS = \
  -I$(top_srcdir) \
  -I$(top_srcdir)/clutk \
  -I$(top_builddir)/clutk \
  -DTESTDIR=\""$(top_srcdir)/tests"\" \
  $(GCC_FLAGS) \
  $(CLUTTER_CFLAGS) \
  $(CLUTTER_GTK_CFLAGS) \
  $(GTK_CFLAGS) \
  $(MAINTAINER_CFLAGS)

test_clutk_perf_CPPFLAGS = \
  -I$(top_srcdir) \
  -I$(top_srcdir)/clutk \
  -I$(top_builddir)/clutk \
  -DTESTDIR=\""$(top_srcdir)/tests"\" \
  $(GCC_FLAGS) \
  $(CLUTTER_CFLAGS) \
  $(CLUTTER_GTK_CFLAGS) \
  $(GTK_CFLAGS) \
  $(MAINTAINER_CFLAGS)

test_clutk_text_CPPFLAGS = \
  -I$(top_srcdir) \
  -I$(top_srcdir)/clutk \
  -I$(top_builddir)/clutk \
  -DTESTDIR=\""$(top_srcdir)/tests"\" \
  $(GCC_FLAGS) \
  $(CLUTTER_CFLAGS) \
  $(CLUTTER_GTK_CFLAGS) \
  $(GTK_CFLAGS) \
  $(MAINTAINER_CFLAGS)

test_clutk_LDADD = \
  $(top_builddir)/clutk/libclutk-0.3.la \
  $(CLUTTER_LIBS) \
  $(CLUTTER_GTK_LIBS) \
  $(GTK_LIBS)

test_clutk_perf_LDADD = \
  $(top_builddir)/clutk/libclutk-0.3.la \
  $(CLUTTER_LIBS) \
  $(CLUTTER_GTK_LIBS) \
  $(GTK_LIBS)

test_clutk_text_LDADD = \
  $(top_builddir)/clutk/libclutk-0.3.la \
  $(CLUTTER_LIBS) \
  $(CLUTTER_GTK_LIBS) \
  $(GTK_LIBS)

EXTRA_DIST = \
  20x20.png \
  ubuntu.svg \
  create-fps-graph.gnuplot \
  gpu \
  ogl \
  run-fps-graph.sh \
  run-perf-tests.sh

#run make test as part of make check
check-local: test
test:
	@gtester -k -o=test-clutk-results.xml ./test-clutk

test-perf:
	@gtester -k -o=test-clutk-perf-results.xml ./test-clutk-perf

.PHONY: check-report full-report
check-report:
	@gtester -k -o=test-clutk-results.xml -k ./test-clutk \
		&& ( gtester-report test-clutk-results.xml \
				| sed 's/GTester Unit Test Report</>GTester Unit Test Report (normal)</' \
				> test-clutk-results.html ) \
		&& gnome-open ./test-clutk-results.html

full-report:
		@gtester -k -o=test-clutk-results.xml -k -m=slow ./test-clutk \
	  && ( gtester-report test-clutk-results.xml \
	      | sed 's/>GTester Unit Test Report</>GTester Unit Test Report (normal)</' \
	      > test-clutk-results.html )

# Xvfb server stuff (thanks Ted!)
XVFB = Xvfb -ac -noreset -screen 0 800x600x16 -extension RANDR -x GLX
XIDS = 101 102 103 104 105 106 107 197 199 211 223 227 293 307 308 309 310 311 \
   491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 \
   991 992 993 994 995 996 997 998 999 1000 1001 1002 1003 1004 1005 1006 1007 \
  1008 1009 4703 4721 4723 4729 4733 4751 9973 9974 9975 9976 9977 9978 9979 \
  9980 9981 9982 9983 9984 9985 9986 9987 9988 9989 9990 9991 9992 9993 9994 \
  9995 9996 9997 9998 9999
XVFB_START = \
	${XVFB} -help 2>/dev/null 1>&2 \
	&& XID=`for id in $(XIDS) ; do test -e /tmp/.X$$id-lock || { echo $$id; exit 0; }; done; exit 1` \
	&& { ${XVFB} :$$XID -screen 0 800x600x16 -nolisten tcp -auth /dev/null >/dev/null 2>&1 & \
	       trap "kill -15 $$! " 0 HUP INT QUIT TRAP USR1 PIPE TERM ; } \
	|| { echo "Gtk+Tests:ERROR: Failed to start Xvfb environment for X11 target tests."; exit 1; } \
	&& DISPLAY=:$$XID && export DISPLAY
# call as: $(XVFB_START) && someprogram

.PHONY: check-headless
check-headless:
	@$(XVFB_START) && gtester -k -o=test-clutk-results.xml ./test-clutk

clean-generic:
	rm -f test-clutk-results.xml test-clutk-results.html test-surface-blur-after.png test-surface-blur-before.png
